diff -r c64dcc4d2eca xen/arch/x86/shutdown.c
--- a/xen/arch/x86/shutdown.c	Thu Feb 10 17:24:41 2011 +0000
+++ b/xen/arch/x86/shutdown.c	Mon Feb 14 11:30:53 2011 +0900
@@ -30,6 +30,7 @@
         BOOT_KBD = 'k',
         BOOT_ACPI = 'a',
         BOOT_BIOS = 'b',
+        BOOT_PCI = 'p',
 };
 
 static long no_idt[2];
@@ -43,6 +44,7 @@
  * triple Force a triple fault (init)
  * kbd    Use the keyboard controller. cold reset (default)
  * acpi   Use the RESET_REG in the FADT
+ * pci    Use PCI
  */
 static enum reboot_type reboot_type = BOOT_ACPI;
 static void __init set_reboot_type(char *str)
@@ -64,6 +66,7 @@
         case 'a':
         case 'k':
         case 't':
+        case 'p':
             reboot_type = *str;
             break;
         }
@@ -375,6 +378,15 @@
             acpi_reboot();
             reboot_type = BOOT_KBD;
             break;
+        case BOOT_PCI:
+            {
+                u8 val = inb(0x0CF9) & ~0x6;
+                outb(val | 0x2, 0xCF9);
+                udelay(50);
+                outb(val | 0x6, 0xCF9);
+                udelay(50);
+            }
+            break;
         }
     }
 }
